package net.mcreator.minotown.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.minotown.world.inventory.FACINMenu;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class FACINScreen extends AbstractContainerScreen<FACINMenu> {
	private final static HashMap<String, Object> guistate = FACINMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;

	public FACINScreen(FACINMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("minotown:textures/screens/facin.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(ResourceLocation.parse("minotown:textures/screens/i.png"), this.leftPos + 51, this.topPos + 97, 0, 0, 64, 64, 64, 64);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.minotown.facin.label_residental"), 6, 7, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.minotown.facin.label_a_happy_place_for_you_people_to"), 6, 52, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.minotown.facin.label_to_live_in"), 6, 70, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
	}
}
